Subject: Re: bug#3454: <SPC> when reading the emacs manual sometimes goes to the wrong node
From: Eli Zaretskii <[email-masked]>
To: Shannon Jones <[email-masked]>, [email-masked]
Date: Wed, 03 Jun 2009 11:39:17 -0400

> Date: Wed, 3 Jun 2009 00:40:37 -0500
> From: Shannon Jones <[email-masked]>
> Cc: 
> Reply-To: Shannon Jones <[email-masked]>, [email-masked]
> 
> Run emacs -Q
> C-h r (Reads emacs manual)
> g Command Index (takes you to the "Command and Function Index" page of the
> manual)
> M-> (Go to end of info node)
> 
> At this point, your cursor should be at the end of the info node that lists
> all commands and functions.  Note that at the top, the next node is listed
> as "Variable Index".  I would expect that pressing <SPC> would take you to
> this node.  However, if you press <SPC> it takes you to some other node.  It
> takes me to the middle of the node "49 Two-Column Editing".

This is not a bug: SPC does _not_ necessarily go to the Next node;
instead, it traverses the nodes as a tree: if there is a menu in the
current node, it takes you to the first menu item of that menu.

If you need to go to the Next node, type `n', not SPC.

> According to the manual for Info, "You can read an entire manual top to
> bottom by just typing <SPC>".

Right, but by going to the Next node you will not end up reading the
whole manual, because Next does not descend to sections, subsections,
subsubsections, etc.  SPC does, so it does indeed guarantee that you
end up reading the whole manual in the logical order: before you move
to the next chapter, you read all the sections and subsections of the
current chapter.

This logic does TRT in nodes that are not indices, because an index is
ordered alphabetically, not in any meaningful order as far as the
sections are concerned.

Morale: do not use SPC at the end of an index, use `n'.

I'm closing this report.